#! /usr/local/bin/perl -w
# $Id: bindtest.pl,v 1.1.2.1 2004/04/01 03:12:55 carl Exp $

BEGIN {
  unshift(@INC, "..");
}

#use strict;
use Getopt::Long;
use Data::Dumper;

my $debug = 0;

my $t = undef;
my $e = undef;
my $s = undef;
my $o = undef;
my $l = undef;
my $m = undef;


my %vars = ( toggle => 1,
			 entry => "hello",
			 spin => 15,
			 option => 'opt1',
			 singleList => 0,
			 multiList => [1,4],
		   );

sub on_quit_activate {
  Exit();
}


sub Exit {
  Gtk2->main_quit;
  exit;
}

sub ShowVars {
  print Dumper(\%vars), "\n";
}

sub ResetVars {
  $vars{'entry'} = "Reset";
  $vars{'spin'} = "24";
  $vars{'option'} = "opt3";
  $vars{'toggle'} = 0;
  $vars{'singleList'} = 3;
  @{$vars{'multiList'}} = ( 2,3,5,7 );

  $t->update_widget();
  $e->update_widget();
  $s->update_widget();
  $o->update_widget();
  $l->update_widget();
  $m->update_widget();
}

sub on_quit1_activate {

  Gtk2->main_quit;
  ShowVars();
  exit;
}

sub InitWidgets {

  use Gtk2 -init;
  use Gtk2::GladeXML;
  use Gtk2::SimpleList;
  use Gtk2::Simple::Bind::OptionMenu;
  use Gtk2::Simple::Bind::ToggleButton;
  use Gtk2::Simple::Bind::Entry;
  use Gtk2::Simple::Bind::SpinButton;
  use Gtk2::Simple::Bind::List;

  $glade = Gtk2::GladeXML->new('simpletest.glade', 'toplevel');
  my $toplevel = $glade->get_widget('toplevel');
  $toplevel->signal_connect('delete_event', \&Exit);

  $t = Gtk2::Simple::Bind::ToggleButton
	  ->new_from_widget($glade->get_widget('toggle'), \$vars{'toggle'});

  $e = Gtk2::Simple::Bind::Entry
	  ->new_from_widget($glade->get_widget('entry'), \$vars{'entry'});

  $s = Gtk2::Simple::Bind::SpinButton
	  ->new_from_widget($glade->get_widget('spin'), \$vars{'spin'});

  $o = Gtk2::Simple::Bind::OptionMenu
	  ->new_from_widget($glade->get_widget('option'), \$vars{'option'},
						'option 0' => 'opt0',
						'option 1' => 'opt1',
						'option 2' => 'opt2',
						'option 3' => 'opt3',
					   );

  my @listEntries = ();
  for(my $i = 0; $i < 10; ++$i){
	push @listEntries, "Entry $i";
  }

  $l = Gtk2::Simple::Bind::List
	  ->new_from_widget($glade->get_widget('singleList'), "Single Select",
						\$vars{'singleList'}, @listEntries);

  $m = Gtk2::Simple::Bind::List
	  ->new_from_widget($glade->get_widget('multiList'), "Multi Select",
						$vars{'multiList'}, @listEntries);

  $glade->get_widget('update')
	  ->signal_connect('pressed' => \&ShowVars);

  $glade->get_widget('reset')
	  ->signal_connect('pressed' => \&ResetVars);

  $glade->signal_autoconnect_from_package();

  $toplevel->show_all;
}

{
  InitWidgets();
  Gtk2->main;
}
