#! /usr/local/bin/perl -w
# $Id: bindtest2.pl,v 1.1.2.1 2004/04/01 03:12:55 carl Exp $

BEGIN {
  unshift(@INC, "..");
}

#use strict;
use Getopt::Long;
use Data::Dumper;

my $debug = 0;

my $t = undef;
my $e = undef;
my $s = undef;
my $o = undef;
my $l = undef;
my $m = undef;


my %vars = ( toggle => 1,
			 entry => "hello",
			 spin => 15,
			 option => 1,
			 singleList => 0,
			 multiList => [1,4],
		   );

sub on_quit_activate {
  Exit();
}


sub Exit {
  Gtk2->main_quit;
  exit;
}

sub ShowVars {
  print Dumper(\%vars), "\n";
}

sub ResetVars {
  $vars{'entry'} = "Reset";
  $vars{'spin'} = "24";
  $vars{'option'} = 3;
  $vars{'toggle'} = 0;
  $vars{'singleList'} = 3;
  @{$vars{'multiList'}} = ( 2,3,5,7 );

  $t->update_widget();
  $e->update_widget();
  $s->update_widget();
  $o->update_widget();
}

sub on_quit1_activate {

  Gtk2->main_quit;
  ShowVars();
  exit;
}

sub InitWidgets {

  use Gtk2 -init;
  use Gtk2::GladeXML;
  use Gtk2::SimpleList;
  use Gtk2::Simple::OptionMenu;
  use Gtk2::BindScalar;

  $glade = Gtk2::GladeXML->new('simpletest.glade', 'toplevel');
  my $toplevel = $glade->get_widget('toplevel');
  $toplevel->signal_connect('delete_event', \&Exit);

  $t = Gtk2::BindScalar->new(\$vars{'toggle'}, $glade->get_widget('toggle'));
  $e = Gtk2::BindScalar->new(\$vars{'entry'}, $glade->get_widget('entry'));
  $s = Gtk2::BindScalar->new(\$vars{'spin'}, $glade->get_widget('spin'));

  Gtk2::BindScalar::register_connection_info('Gtk2::Simple::OptionMenu',
											 [ ['changed'], ['history'] ]);

  print Dumper(\%Gtk2::BindScalar::connInfo), "\n";
  my $opt = Gtk2::Simple::OptionMenu
	  ->new_from_widget($glade->get_widget('option'), 
						'option 0' => 'opt0',
						'option 1' => 'opt1',
						'option 2' => 'opt2',
						'option 3' => 'opt3',
					   );
  $o = Gtk2::BindScalar->new(\$vars{'option'}, $opt);

  $glade->get_widget('update')
	  ->signal_connect('pressed' => \&ShowVars);

  $glade->get_widget('reset')
	  ->signal_connect('pressed' => \&ResetVars);

  $glade->signal_autoconnect_from_package();

  $toplevel->show_all;

  $glade->get_widget('scrolledwindow1')->hide();
  $glade->get_widget('scrolledwindow2')->hide();

}

{
  InitWidgets();
  Gtk2->main;
}
