#! /usr/local/bin/perl -w
# $Id: tietest.pl,v 1.1.2.1 2004/04/01 03:12:56 carl Exp $

BEGIN {
  unshift(@INC, "..");
}

#use strict;
use Getopt::Long;
use Data::Dumper;

my $debug = 0;

my $t = undef;
my $e = undef;
my $s = undef;
my $o = undef;
my $l = undef;
my $m = undef;

my %vars = ( toggle => 1,
			 entry => "hello",
			 spin => 15,
			 option => 'opt1',
			 singleList => 0,
			 multiList => [],
		   );

sub on_quit_activate {
  ExitPrompt();
}

sub ExitPrompt {
  my $dataSrc = shift || "";

  my $gl = Gtk2::GladeXML->new('simpletest.glade', 'exitWarningDialog');
  my $d = $gl->get_widget('exitWarningDialog');

  my $result = $d->run;
  print "Result: $result\n";
  if($result eq 'close'){
	Exit();
  }

  $d->destroy;
  return 1;
}

sub ShowVars {
  print Dumper(\%vars), "\n";
}

sub ResetVars {
  $vars{'entry'} = "Reset";
  $vars{'spin'} = "24";
  $vars{'option'} = "opt3";
  $vars{'toggle'} = 0;
  $vars{'singleList'} = 3;
  $vars{'multiList'}->[2] = 1;
  $vars{'multiList'}->[3] = 1;
  $vars{'multiList'}->[5] = 1;
  $vars{'multiList'}->[7] = 1;
}

sub on_quit1_activate {

  Gtk2->main_quit;
  ShowVars();
  exit;
}

sub InitWidgets {

  use Gtk2 -init;
  use Gtk2::GladeXML;
  use Gtk2::SimpleList;
  use Gtk2::Simple::Tie::OptionMenu;
  use Gtk2::Simple::Tie::ToggleButton;
  use Gtk2::Simple::Tie::Entry;
  use Gtk2::Simple::Tie::SpinButton;
  use Gtk2::Simple::Tie::List;

  $glade = Gtk2::GladeXML->new('simpletest.glade', 'toplevel');
  my $toplevel = $glade->get_widget('toplevel');
  $toplevel->signal_connect('delete_event', \&ExitPrompt);

  $t = Gtk2::Simple::Tie::ToggleButton
	  ->new_from_widget($glade->get_widget('toggle'), \$vars{'toggle'});

  $e = Gtk2::Simple::Tie::Entry
	  ->new_from_widget($glade->get_widget('entry'), \$vars{'entry'});

  $s = Gtk2::Simple::Tie::SpinButton
	  ->new_from_widget($glade->get_widget('spin'), \$vars{'spin'});

  $o = Gtk2::Simple::Tie::OptionMenu
	  ->new_from_widget($glade->get_widget('option'), \$vars{'option'},
						'option 0' => 'opt0',
						'option 1' => 'opt1',
						'option 2' => 'opt2',
						'option 3' => 'opt3',
					   );

  my @listEntries = ();
  for(my $i = 0; $i < 10; ++$i){
	push @listEntries, "Entry $i";
  }

  $l = Gtk2::Simple::Tie::List
	  ->new_from_widget($glade->get_widget('singleList'), "Single Select",
						\$vars{'singleList'}, @listEntries);

  $m = Gtk2::Simple::Tie::List
	  ->new_from_widget($glade->get_widget('multiList'), "Multi Select",
						$vars{'multiList'}, @listEntries);

  $glade->get_widget('update')
	  ->signal_connect('pressed' => \&ShowVars);

  $glade->get_widget('reset')
	  ->signal_connect('pressed' => \&ResetVars);

  $glade->signal_autoconnect_from_package();

  $toplevel->show_all;
}

{
  InitWidgets();
  Gtk2->main;
}
