#! /usr/local/bin/perl -w
# $Id: tietest2.pl,v 1.1.2.1 2004/04/01 03:12:56 carl Exp $

BEGIN {
  unshift(@INC, "..");
}

#use strict;
use Getopt::Long;
use Data::Dumper;

my $debug = 0;

my $t = undef;
my $e = undef;
my $s = undef;
my $o = undef;
my $l = undef;
my $m = undef;

my %vars = ( toggle => 1,
			 entry => "hello",
			 spin => 15,
			 option => 'opt1',
			 singleList => 0,
			 multiList => [],
		   );

sub on_quit_activate {
  ExitPrompt();
}

sub ExitPrompt {
  my $dataSrc = shift || "";

  my $gl = Gtk2::GladeXML->new('simpletest.glade', 'exitWarningDialog');
  my $d = $gl->get_widget('exitWarningDialog');

  my $result = $d->run;
  print "Result: $result\n";
  if($result eq 'close'){
	Exit();
  }

  $d->destroy;
  return 1;
}

sub ShowVars {
  print Dumper(\%vars), "\n";
}

sub ResetVars {
  $vars{'entry'} = "Reset";
  $vars{'spin'} = "24";
  $vars{'option'} = "opt3";
  $vars{'toggle'} = 0;
  $vars{'singleList'} = 3;
  $vars{'multiList'} = [ 2,3,5,7 ];
}

sub on_quit1_activate {

  Gtk2->main_quit;
  ShowVars();
  exit;
}

sub InitWidgets {

  use Gtk2 -init;
  use Gtk2::GladeXML;
  use Gtk2::SimpleList;
  use Gtk2::TieScalar;
  use Gtk2::TieArrayRef;

  $glade = Gtk2::GladeXML->new('simpletest.glade', 'toplevel');
  my $toplevel = $glade->get_widget('toplevel');
  $toplevel->signal_connect('delete_event', \&ExitPrompt);

  Gtk2::TieScalar->create(\$vars{'toggle'}, $glade->get_widget('toggle'));
  Gtk2::TieScalar->create(\$vars{'entry'}, $glade->get_widget('entry'));
  Gtk2::TieScalar->create(\$vars{'spin'}, $glade->get_widget('spin'));

  my @listEntries = ();
  for(my $i = 0; $i < 10; ++$i){
	push @listEntries, [ "Entry $i" ];
  }

  $l = Gtk2::SimpleList
	  ->new_from_treeview($glade->get_widget('singleList'), 
						  'Single Select' => 'text');
  $l->set_data_array([@listEntries]);
  Gtk2::TieScalar->create(\$vars{singleList}, $l);

  $m = Gtk2::SimpleList
	  ->new_from_treeview($glade->get_widget('multiList'), 
						  'Multi Select' => 'text');
  $m->set_data_array([@listEntries]);
  $m->get_selection->set_mode ('multiple');
  Gtk2::TieArrayRef->create(\$vars{multiList}, $m);

  $glade->get_widget('update')
	  ->signal_connect('pressed' => \&ShowVars);

  $glade->get_widget('reset')
	  ->signal_connect('pressed' => \&ResetVars);

  $glade->signal_autoconnect_from_package();

  $toplevel->show_all;

  $glade->get_widget('option')->hide();

}

{
  InitWidgets();
  Gtk2->main;
}
